import FNC
import Formulas(formulas,formula1,FC(..))
import System.Environment
import Data.List (intercalate)


menuFormula :: FC -> String 
menuFormula fc =
  "Formule  : " ++ prettyPrint (formula fc)
  ++"\nCommentaire : " ++ (comment fc)

menuFormulas :: [FC] -> String 
menuFormulas formulas =
  let
    items = map (\n -> show n++") ") [1..length formulas]
    formulasStr = map menuFormula formulas
  in
    intercalate "\n" $ map (\(xs,ys) -> xs ++ ys) (zip items formulasStr) 

menu = do
  putStrLn $ menuFormulas formulas
  putStr "Quelle formule : "
  str <- getLine
  return ((read str)::Int)
  
runWithMenu = do
  n <- menu
  let chosenFc = formulas !! (n -1)
  procedure (formula chosenFc)
  
main :: IO ()
main = do
    args <- getArgs
    if (null args) then runWithMenu
      else
      let
        chosenFc = formulas !! (read (args !! 0))
      in
        do
          putStrLn $ menuFormula chosenFc
          procedure (formula chosenFc) 
{--
--}
